
/// <amd-dependency path="text!./gridFooter-template.html" name="gridFooterTemplate" />

declare var gridFooterTemplate;



/**
 * @ngdoc directive
 * @name grid footer directive
 * @description This is the implementation of grid footer directive
 * This directive is part of the the grid-footer component
 * which contains selected rows count and the paginator component.
 * @param {totalRecords} number of total records to be handled by paginator.
 * @param {title} string to be shown in the paginator.
 * @param {selectedRowsCount} number of selected rows from the grid
 * @example <nwf-grid-footer total-records=22 title="Nodes" selected-rows-count=2></nwf-grid-footer>
 *
 */
export class GridFooter{

    static NAME:string = 'nwfGridFooter';

    public scope = {
        totalRecords: '@',
        title: '@',
        selectedRowsCount: '@?',
        offset: '=',
        limit:'='
    };

    public restrict = 'E';
    public replace = true;
    public template = gridFooterTemplate;

    constructor() {

    }

}
// export factory function
export function GridFooterFactory():GridFooter {
    return new GridFooter();
}