export default class SearchController {

    static $inject = ['$scope', '$element'];

    type: string;
    searchVal: string;

    constructor(private $scope, $element: angular.IAugmentedJQuery) {

        var placeholderText = 'Search ' + this.type + ' data';

        $element.find('.grid-search-input').attr('placeholder', placeholderText);

        $scope.$watch('search.searchVal',(newVal, oldVal)=>{
            //if newVal exists, or oldVal exist and newVal!=oldVal, then only we set the q parameter.
           if((newVal || oldVal) && (newVal !== oldVal)){
               this.setMyValue();
           }
        });
    }

    setMyValue() {
        //When doing a search, I reset the offset back to zero.
        this.$scope.paramsCtrl.params.q = this.searchVal || null;
        this.$scope.paramsCtrl.params.offset = 0;
    }

    /* Simple reset */
    resetInput() {
        this.searchVal = '';
        this.setMyValue();
    }

}